<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class ViewStudentsController extends CI_Controller {

	public function index() {
		$this->load->model('user');
		$this->load->model('admin/admin_model');

		if(!$this->user->isLoggedIn() || $this->user->getUserType() != "Teacher") {
			echo "You do not have access to this page.";
			return;
		}

		// NOTE: viewstudents is a deprecated model. Should eventually be replaced by a proper model
		$this->load->model('viewstudents');

		$userName = $this->user->getUserName();
		$userType = $this->user->getUserType();
		
		//Creates an array with the necessary css- and jsfiles needed for the views that are about to be shown.
		$headTagData = array(
			'cssFiles' => array('bannermenu', 'sidemenu', 'dummieContent', 'viewStudents', 'body'),//cms tillfällig sida
			'jsFiles' => array('bannermenu', 'viewStudents')
		);
		
		//Puts the array above in <head></head>
		$this->load->view('headTag', array('headTagData' => $headTagData));	

		$students = $this->viewstudents->getStudents();
		
		$this->load->view('viewStudentsBody', array('students' => $students));
	}

	public function editStudentDetails() {
		$this->load->model('user');
		if(!$this->input->post('username') || !$this->user->isLoggedIn()) {
			echo "You do not have access to this page";
			return;
		}

		$data = array(
			'name' => $this->input->post('name');
		);
	}
	
	public function validate() {
		//Load required library
		$this->load->library('form_validation');
		
		//Sets validation rules
		$this->form_validation->set_rules('username', 'Username', 'trim|required|xss_clean');
		$this->form_validation->set_rules('password', 'Password', 'trim|required|xss_clean');
		
		//Run validation
		if($this->form_validation->run() == FALSE) {
			//Field validation failed. Display login form (with error message).
			$this->drawLoginForm(validation_errors());
		} else {
			$username = $this->input->post('username');
			$password = $this->input->post('password');
			
			//Try to login
			if ($this->user->login($username, $password)) {
				redirect(base_url().'home', 'refresh');
			} else {
				$this->drawLoginForm('Access denied!');
			}
		}
	}
	
}

/* End of file ExamplesController.php */
/* Location: ./application/controllers/ExamplesController.php */