<?php

class Admin extends CI_Controller {

	/*
	* This is the index function. It will be the one called if you do not specify a
	* function in the url, example: /admin/
	*/
	public function index() {
		$this->load->model('admin/Admin_model');
		$courses = $this->Admin_model->getCourses();
		$menu = $this->Admin_model->getMenu();
		$this->load->view('admin/header', array("title" => "Index"));
		$this->load->view('admin/menu', array("menu" => $menu));
		$this->load->view('admin/index', array("courses" => $courses));
	} 

	public function addCourse() {
		$this->load->model('admin/Admin_model');
		if(!isset($_POST['cid'])){
			$this->load->helper('form');
			$this->load->view('admin/header', array("title" => "Add course"));
			$menu = $this->Admin_model->getMenu();
			$this->load->view('admin/menu', array("menu" => $menu));
			$this->load->view('admin/add_course');
		} else {
			
			$this->Admin_model->addCourse($_POST['cid'], $_POST['name']);
			redirect("admin/");
		}
	}

	public function manageCourse($cid) {
		$cid = urldecode($cid);
		$this->load->model('admin/Admin_model');
		$categories = $this->Admin_model->getCategories($cid);
		$this->load->view('admin/header', array("title" => "Manage course - ".$cid));
		$menu = $this->Admin_model->getMenu();
		$this->load->view('admin/menu', array("menu" => $menu));
		$this->load->view('admin/manage_course', array("categories" => $categories, "cid" => $cid));
	}

	public function addCategory($cid){
		$cid = urldecode($cid);
		$this->load->model('admin/Admin_model');
		if(!isset($_POST['categoryName'])){
			$this->load->helper('form');
			$this->load->view('admin/header', array("title" => "Add category"));
			$menu = $this->Admin_model->getMenu();
			$this->load->view('admin/menu', array("menu" => $menu));
			$this->load->view('admin/add_category', array("cid" => $cid));
		} else {
			
			$this->Admin_model->addCategory($_POST['cid'], $_POST['categoryName']);
			redirect("admin/");
		}
	}

	public function manageCategory($cid, $categoryName) {
		$cid = urldecode($cid);
		$categoryName = urldecode($categoryName);
		$this->load->model('admin/Admin_model');
		$subcategories = $this->Admin_model->getSubCategories($cid,  $categoryName);
		$this->load->view('admin/header', array("title" => "Manage category - ".$cid." - ". $categoryName));
		$menu = $this->Admin_model->getMenu();
		$this->load->view('admin/menu', array("menu" => $menu));
		$this->load->view('admin/manage_category', array("subcategories" => $subcategories, "cid" => $cid, "categoryName" => $categoryName));
	}

	public function addSubCategory($cid, $categoryName){
		$cid = urldecode($cid);
		$categoryName = urldecode($categoryName);
		$this->load->model('admin/Admin_model');
		if(!isset($_POST['subcategoryname'])){
			$this->load->helper('form');
			$this->load->view('admin/header', array("title" => "Add subcategory"));
			$menu = $this->Admin_model->getMenu();
			$this->load->view('admin/menu', array("menu" => $menu));
			$this->load->view('admin/add_sub_category', array("cid" => $cid, "category" => $categoryName));
		} else {
		
			$this->Admin_model->addSubCategory($_POST['cid'], $_POST['category'], $_POST['subcategoryname']);
			redirect("admin/");
		}
	}

	public function manageSubCategory($cid, $categoryName, $subCategoryName) {
		$cid = urldecode($cid);
		$categoryName = urldecode($categoryName);
		$subCategoryName = urldecode($subCategoryName);
		$this->load->model('admin/Admin_model');
		$examples = $this->Admin_model->getExamples($cid,  $categoryName, $subCategoryName);
		$quizzes = $this->Admin_model->getQuizzes($cid,  $categoryName, $subCategoryName);
		$this->load->view('admin/header', array("title" => "Manage category - ".$cid." - ". $categoryName));
		$menu = $this->Admin_model->getMenu();
		$this->load->view('admin/menu', array("menu" => $menu));
		$this->load->view('admin/manage_sub_category', array("examples" => $examples, "quizzes" => $quizzes , "cid" => $cid, "categoryName" => $categoryName, "subCategoryName" => $subCategoryName));
	}

	public function addExample($cid, $categoryName, $subCategoryName){
		$cid = urldecode($cid);
		$categoryName = urldecode($categoryName);
		$subCategoryName = urldecode($subCategoryName);
		$this->load->model('admin/Admin_model');
		if(!isset($_POST['example'])){
			$this->load->helper('form');
			$this->load->view('admin/header', array("title" => "Add example"));
			$menu = $this->Admin_model->getMenu();
			$this->load->view('admin/menu', array("menu" => $menu));
			$this->load->view('admin/add_example', array("cid" => $cid, "categoryName" => $categoryName, "subCategoryName" => $subCategoryName));
		} else {
			
			$this->Admin_model->addExample($_POST['cid'],  $_POST['categoryName'], $_POST['subCategoryName'], $_POST['example'], $_POST['description']);
			redirect("admin/");
		}
	}

	public function manageExample($cid, $categoryName, $subCategoryName, $example) {
		$cid = urldecode($cid);
		$example = urldecode($example);
		$categoryName = urldecode($categoryName);
		$subCategoryName = urldecode($subCategoryName);
		if(!isset($_POST['documentation'])){
			$this->load->helper('form');

			$this->load->model('codeviewer/Codeviewer_model');
			
			$editorHTML = $this->Codeviewer_model->getCode($cid, $categoryName, $subCategoryName, $example);

			//$doc = $this->Codeviewer_model->getDoc($cid, $example, $page);

			$this->load->view('admin/header', array("editors" => $editorHTML, "title" => "Manage example - ".$categoryName." - ".$subCategoryName." - ".$example." - ".$cid));
			$this->load->view('admin/manage_example', array("cid" => $cid, "example" => $example, "category" => $categoryName, "subcategory" => $subCategoryName /*,"documentation" => $doc*/));
		} else {
			$this->load->model('admin/Admin_model');
			$this->Admin_model->updateExample($_POST['cid'], $_POST['example'],$_POST['category'], $_POST['subcategory'], $_POST['documentation'], $_POST['files']);
			redirect("admin/");
		}
	}

	public function uploadFile($cid, $categoryName, $subCategoryName, $example) {
		$cid = urldecode($cid);
		$example = urldecode($example);
		$categoryName = urldecode($categoryName);
		$subCategoryName = urldecode($subCategoryName);
		$this->load->model('admin/Admin_model');
		$this->Admin_model->uploadFile($_FILES['files'],$cid, $categoryName, $subCategoryName, $example);
	}

}