<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	class Ajax extends CI_Controller {
		/*
		 *	Constructor
		 */
		function __construct() {
			parent::__construct();
			
			//Load required library
			$this->load->model('user', '', TRUE);
		}
		
		/*
		 *	This function loads a popupview to be displayed, the argument is the name of the popupview
		 */
		public function popup($popupName) {
			$this->load->view('popup/'.$popupName);
		}

		function showPopup($popupName) {
			$headTagData = array(
				'cssFiles' => array('popup'),
				'jsFiles' => array('login')
			);

			$userInfo = array(
				'userType' => $this->user->getUserType(), // Loads different header for teacher/student
				'userName' => $this->user->getUserName()
			);

			// Loads head views, supplying CSS and JS data
			$this->load->view('headTag', array('headTagData' => $headTagData));

			$this->load->view('popup/'.$popupName);
		}
		
		/*
		 *	This function return TRUE if the user is logged in and FALSE otherwise.
		 */
		public function isLoggedIn() {
			if ($this->user->isLoggedIn()) {
				echo 'yes';
			}
			else {
				echo 'no';
			}
		}

		function 
		
		/*
		 *	This function outputs data: user password hint.
		 */
		public function pwdhint() {
			$this->load->model('user');
			if($this->input->post('username')) {
				$username = $this->input->post('username');
				$data = array(
					'hint' => $this->user->getPasswordHint($username)
				);
			
				//Output JSON data
				echo json_encode($data);
			}
		}

		/*
		 *	This function outputs data: user password hint.
		 */
		public function ladok() {
			$string = $this->input->post('data');
			
			$parsedArray = $this->user->parseLadok($string);
			
			if ($parsedArray === FALSE) {
				$data = array('status' => FALSE);				
			} else {
				//Add users to database
				foreach ($parsedArray as $key => $value) {
					$this->user->addUser($parsedArray[$key]['username'], $parsedArray[$key]['firstname'] . ' ' . $parsedArray[$key]['lastname'], $parsedArray[$key]['ssn'], $parsedArray[$key]['ssn'], 'Student', 'Default', $parsedArray[$key]['email']);
				}
			
				$data = array('status' => TRUE);			
			}
			
			//Output JSON data
			echo json_encode($data);
		}
		
		/*
		 *	This function outputs data: user password hint.
		 */
		public function pwdchange() {
			$pwdOld = $this->input->post('currentPwd');
			$pwdNew = $this->input->post('newPwd');
			$pwdHint = $this->input->post('hintPwd');
		
			$data = array(
				'status' => $this->user->changePassword($pwdOld, $pwdNew, $pwdHint)
			);
			
			//Output JSON data
			echo json_encode($data);
		}
		
		public function categoryOrderDecrease(){
			$pwdOld = $this->input->post('currentPwd');
			$pwdNew = $this->input->post('newPwd');
		}

		// Takes a course ID and sets the course to published (isHidden = 0)
		public function publishCourse($courseID) {
			$this->load->model('user');
			$this->load->model('admin/admin_model');

			if(!$this->user->isLoggedIn() || $this->user->getUserType() != "Teacher") {
				$this->load->view('manageCoursesMessage', array('message' => 'You do not have access to this page'));
				echo "not logged in";
				return;
			}

			$this->admin_model->unsetCourseHidden($courseID);
		}

		//Takes a course ID and sets the course to unpublished (isHidden = 1)
		public function unpublishCourse($courseID) {
			$this->load->model('user');
			$this->load->model('admin/admin_model');

			if(!$this->user->isLoggedIn() || $this->user->getUserType() != "Teacher") {
				$this->load->view('manageCoursesMessage', array('message' => 'You do not have access to this page'));
				echo "not logged in";
				return;
			}
			
			$this->admin_model->setCourseHidden($courseID);
		}
	}
?>