<?php
class Codeviewer_model extends CI_Model {

	function __construct(){
		$this->load->database();
	}

	function getCode($cid, $category, $subcategory, $example) {

		$this->db->from('Files');
		$this->db->join("Containers", "Containers.fileName = Files.fileName");
		$this->db->where("Containers.categoryName", $category);
		$this->db->where("Containers.subcategoryName", $subcategory);
		$this->db->where("Containers.exampleName", $example);
		$this->db->where("Containers.courseID", $cid);
		//$this->db->not_like("Containers.fileName", $cid."/".$category."/".$subcategory."/".$example."/documentation");

		$query = $this->db->get();
		$outarr = array();
		$column1 = 0;
		$column2 = 0;
		foreach ($query->result() as $row) {
			if ($row->columnNr == 1) $column1++;		
			if ($row->columnNr == 2) $column2++;		
		}
		foreach ($query->result() as $row) { //creats array with array consisting of columnNr and code file.
			$output = "";
			if($row->columnNr == 1 && $column1 == 1 ) {
				$output .= '<div class="singleColumn1">';
			} else if($row->columnNr == 1 && $column1 == 2) {
				$output .= '<div class="doubleColumn1">';
			} else if($row->columnNr == 2 && $column2 == 1) {
				$output .= '<div class="singleColumn2">';
			} else if($row->columnNr == 2 && $column2 == 2) {
				$output .= '<div class="doubleColumn2">';
			} else if($row->columnNr == 2 && $column2 == 3) {
				$output .= '<div class="tripleColumn2">';
			} else {
				$output .= '<div class="tripleColumn2">';
			}

			if($row->fileType == 'Code') {
				$filename = $row->fileName;
				$pieces = explode("/", $filename);
				$filename = $pieces[4];
				$output .= '<div class="editorinfo"><span class="codeLanguage">'.$row->codeLanguage.'</span><span class="codeFilename">'.$filename.'</span></div>';
				$output .= '<div id="ace_'.str_replace(".", "", $row->fileName).'" class="ace">';
				$output .= $row->dataBlob;
				$output .= '</div>';

				$output .= '<script type="text/javascript">
				var Range = require("ace/range").Range;
				var editor = ace.edit("ace_'.str_replace(".", "", $row->fileName).'");
				editor.setTheme("ace/theme/eclipse");
				editor.getSession().setMode("ace/mode/'.$row->codeLanguage.'");
				editor.setReadOnly(true);
				editor.setShowPrintMargin(false);
				editor.setDisplayIndentGuides(false);
				editor.setHighlightSelectedWord(true);
				lines = editor.getSession().getLength();
				$("#ace_'.str_replace(".", "", $row->fileName).'").height(Math.min(500,lines*16));
				aceeditors.push("ace_'.str_replace(".", "", $row->fileName).'");';

				/*
				for($i = 0; $i < count($interestingrows); $i++) {
				$output .= 'editor.getSession().addMarker(new Range('.$interestingrows[$i][0].', 0, '
					.$interestingrows[$i][1].', Number.POSITIVE_INFINITY), "interesting", "text",false);';
				}
				*/
				$output .= '</script>';
			} else if($row->fileType == 'Text') {
				$output .= '<div class="editorinfo"><span class="codeFilename">Description</span></div>';
				$output .= '<div class="textContainer">';
				$output .= $row->dataBlob;
				$output .= '</div>';
			}
			$output .= '</div>';
			$outarr[] = array($row->columnNr,$output);

		}

		return $outarr;
	}

	/*
	function getDoc($cid, $category, $subcategory, $example){
		$this->db->select('dataBlob');
		$this->db->from('Files');
		$this->db->join("Containers", "Containers.fileName = Files.fileName");
		$this->db->where("Containers.categoryName", $category);
		$this->db->where("Containers.subcategoryName", $subcategory);
		$this->db->where("Containers.exampleName", $example);
		$this->db->where("Containers.courseID", $cid);
		$this->db->where("Containers.fileName", $cid."/".$category."/".$subcategory."/".$example."/"."documentation");

		$query = $this->db->get();
		$result = $query->result();
		return $result[0]->dataBlob;
	}*/
}
