<?php
	class Stats extends CI_Model {
	
		function __construct() {
			parent::__construct();
			$this->load->library('user_agent');
		}


		/*
		 *	This function returns an array with user stats.
		 */ 
		 		
		public function getUserStats() {
			//Dummy-array to be filled
			$userStats = array(
				'agentType' => 'unknown',
				'agentName' => 'unknown',
				'agentVersion' => 'unknown',
				'agentPlatform' => 'unknown',
				'agentString' => 'unknown'	
			);
		
			//If user is using a web browser
			if($this->agent->is_browser()) {
				$userStats['agentType'] = 'browser';
				$userStats['agentName'] = $this->agent->browser();
				$userStats['agentVersion'] = $this->agent->version();
			}
			//If user is using a mobile browser
			elseif ($this->agent->is_mobile()) {
				$userStats['agentType'] = 'mobile';
				$userStats['agentName'] = $this->agent->mobile();
			}
			//If user is a robot
			elseif ($this->agent->is_robot()) {
				$userStats['agentType'] = 'robot';
				$userStats['agentName'] = $this->agent->robot();
			}
			
			//Common stats
			$userStats['agentPlatform'] = $this->agent->platform();
			$userStats['agentString'] = $this->agent->agent_string();
			
			//Return result
			return $userStats;
		}
		
		
		/*
		 *	This function returns an array with system stats.
		 */ 		
		
		public function getSystemStats() {
			//Dummy-array to be filled
			$systemStats = array(
				'courseAmount' => 'unknown',
				'exampleAmount' => 'unknown',
				'quizAmount' => 'unknown'	
			);
			
			//Get amount of courses
			$query = $this->db->get('Courses');
			$systemStats['courseAmount'] = $query->num_rows();
			
			//Get amount of examples
			$query = $this->db->get('Examples');
			$systemStats['exampleAmount'] = $query->num_rows();
			
			//Get amount of quizzes
			$query = $this->db->get('Quizzes');
			$systemStats['quizAmount'] = $query->num_rows();
			
			//Return result
			return $systemStats;
		}
		
		
		/*
		 *	This function returns an array with course stats.
		 */ 
		
		public function getCourseStats() {
			//Dummy-array to be filled
			$courseStats = array(
				'exampleAmount' => 'unknown',
				'quizAmount' => 'unknown'	
			);
			
			//Return result
			return $courseStats;	
		}
	}
?>